﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Collections;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Drawing.Drawing2D;
using System.IO;
using System.IO.Ports;
using System.Net;
using System.Threading;
using Microsoft.VisualBasic;
using System.Windows.Forms;

using NationalInstruments;
using NationalInstruments.UI;
using NationalInstruments.DAQmx;
using NationalInstruments.NI4882;
using NationalInstruments.VisaNS;
using NationalInstruments.Analysis;
using NationalInstruments.Analysis.Conversion;
using NationalInstruments.Analysis.SignalGeneration;
using NationalInstruments.UI.WindowsForms;
using NationalInstruments.Controls;
using NationalInstruments.Controls.Rendering;



namespace SketchDrive
{
    public partial class Form1 : Form
    {

        #region " Paint Declarations"

        int PenSize = 36;

        bool CirclePath = true;

        bool LeftIsDown = false;

        bool RightIsDown = false;

        Image StartImage;
        Point PrevPos;

        Point StartPos;
        Point FormStartCurPos;

        Point FormStartPos;
        #endregion


        #region "SketchDrive Declaration"

        int[] xpos = new int[65000];
        int[] ypos = new int[65000];

        int[] Xval = new int[64];
        int[] Yval = new int[64];

        UInt32 gi = 0;
        byte[] rxbuf = new byte[10];

        UInt32 pcount = 0;
        int npoints;
        bool Connected = false;
        bool RoutingError = false;
        bool IsRunning = false;
        bool Startup = false;
        bool Stopped = false;
        bool pathfound = false;
        bool drivecompleted = false;
        int Reverse_Enable = 0;
        int Lights_ON = 0;
        
        float Voltage = 0;
        int prev_Gaugevalue = 0;
        int Speed = 0;
        bool pause = false;
        bool rotating = false;
        int picH = 30;
        int picW = 30;


        int[] Dir = new int[65000];
        int pDir = 0;
        int[] xDir = new int[65000];
        int[] yDir = new int[65000];
        int[] Prev_Dir = new int[65000];

        int xdirection, ydirection, mval;

        String ReEn = "0";
        String EngSpVal = "0";
        String TuDel = "0";
        String rxString = null;
        


        public int[] Error_Value = new int[10] { 7, 8, 9, 10, 11, 12, 13, 14, 15, 16 };
        public int[] Sense_Value = new int[4] { 1, 2, 3, 4 };
        public int[] Engine_Speed = new int[11] { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 , 9};
        public int[] Turn_Delay = new int[11] { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 , 9 };
        int Sense_Plus, Sense_Minus;

        Stopwatch Stopwatch1;
        bool OpMode = false;
        //Test Mode

      
            int td_Drive = 0;
            int td_Drift = 0;
            int td_Circuit = 0;
            int td_Reverse = 0;
            int td_Left = 0;
            int td_Right = 0;
            uint td_SpeedVal = 0;
            string td_Speed = "000";
            uint td_MaxSpeed = 0;
            int td_gear_count = 0;
            int td_LorR = 0;
     



        #endregion

        #region "Thread Declaration"

        Thread StartupThread,StoppedThread, RunThread, GraphicThread, GaugeThread,SetMeterThread,ResetMeterThread;
        delegate void SetValueCallback(Control ctrl, string value);
        delegate void SetGaugeValueCallback(Gauge ctrl, int value);



        #endregion



        #region "Form Functions"

        public Form1()
        {
            InitializeComponent();

            FormClosing += Form1_FormClosing;
            this.panel1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseUp);
            this.panel1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseDown);
            this.pictureBox1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseMove);
            this.pictureBox1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseUp);
            this.pictureBox1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseDown);

            this.serialPort1.DataReceived += new SerialDataReceivedEventHandler(DataReceivedHandler);

           // Touch.FrameReported += new TouchFrameEventHandler(Touch_FrameReported);
           
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            CirclePath = true;
            MARGINS margins = new MARGINS();
            Stopwatch1 = new Stopwatch();

        
            margins.cxLeftWidth = 0;
            margins.cxRightWidth = 0;
            margins.cyTopHeight = 0;
            margins.cyBottomHeight = 0;
            IntPtr hwnd = Handle;
            int result = DwmExtendFrameIntoClientArea(hwnd, ref margins);

            pictureBox1.Image = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            Graphics gfx = Graphics.FromImage(pictureBox1.Image);
            gfx.Clear(Color.FromArgb(255, 255, 255, 255));
            pictureBox1.Refresh();
            timer2.Enabled = true;
            timer2.Interval = 3000;
            timer3.Enabled = true;
            timer3.Interval = 500;

            this.GaugeThread = new Thread(new ThreadStart(this.SetGauge));
            this.GaugeThread.Start();
            
        }

        private void Form1_FormClosing(object sender, EventArgs e)
        {

            //Reset the state of the application objects
            Connected = false;
            buttonConnect.Text = "Connect";
            comboBox1.Enabled = true;

            GaugeThread.Abort();
            try
            {
                //Dispose the In and Out buffers;
                serialPort1.DiscardInBuffer();
                serialPort1.DiscardOutBuffer();

                //Close the COM port
                serialPort1.Close();
            }
            //If there was an exeception then there isn't much we can
            //  do.  The port is no longer available.
            catch { }
        }


        #endregion 

        #region "Form Border"
        [StructLayout(LayoutKind.Sequential)]
        public struct MARGINS
        {
            public int cxLeftWidth;
            public int cxRightWidth;
            public int cyTopHeight;
            public int cyBottomHeight;
        }
        [DllImport("dwmapi.dll")]
        public static extern int DwmExtendFrameIntoClientArea(IntPtr hWnd, ref MARGINS pMarinset);

        //Form Moving on extended border:
        private void panel1_MouseDown(System.Object sender, System.Windows.Forms.MouseEventArgs e)
        {
            if (e.Button.ToString() == "Left")
            {
                
                FormStartCurPos=System.Windows.Forms.Cursor.Position; 
                FormStartPos = this.Location;
                timer1.Enabled = true;

                
            }
        }
        private void panel1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
        {

            timer1.Enabled = false;

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            this.Location = new Point(FormStartPos.X - (FormStartCurPos.X - System.Windows.Forms.Cursor.Position.X), FormStartPos.Y - (FormStartCurPos.Y - System.Windows.Forms.Cursor.Position.Y));
            
        }

        #endregion


        #region "Draw"


        private void pictureBox1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
        {

            StartImage = new Bitmap(pictureBox1.Image);

            if (e.Button == System.Windows.Forms.MouseButtons.Left & !RightIsDown)
            {
                //Left

                Graphics gfx = Graphics.FromImage(pictureBox1.Image);

                if (CirclePath)
                {
                    gfx.FillEllipse(new SolidBrush(Color.Black), e.X - (PenSize / 2), e.Y - (PenSize / 2), PenSize, PenSize);
                }
                else
                {
                    gfx.FillRectangle(new SolidBrush(Color.Black), e.X - (PenSize / 2), e.Y - (PenSize / 2), PenSize, PenSize);
                }

                pictureBox1.Refresh();

                LeftIsDown = true;
            }
            else if (e.Button == System.Windows.Forms.MouseButtons.Right & !LeftIsDown)
            {
                //Right

                Graphics gfx = Graphics.FromImage(pictureBox1.Image);

                if (CirclePath)
                {
                    gfx.FillEllipse(new SolidBrush(Color.Black), e.X - (PenSize / 2), e.Y - (PenSize / 2), PenSize, PenSize);
                }
                else
                {
                    gfx.FillRectangle(new SolidBrush(Color.Black), e.X - (PenSize / 2), e.Y - (PenSize / 2), PenSize, PenSize);
                }

                pictureBox1.Refresh();


                RightIsDown = true;
            }
            StartPos = e.Location;
            PrevPos = e.Location;
        }


        private void pictureBox1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                xpos[pcount] = e.X;
                ypos[pcount] = e.Y;
                pcount++;

            }

            if (e.Button == System.Windows.Forms.MouseButtons.Left & !RightIsDown)
            {
                //Left

                Pen Pencil = new Pen(Color.Black, PenSize);
                Graphics gfx = Graphics.FromImage(pictureBox1.Image);
                gfx.DrawLine(Pencil, PrevPos, e.Location);

                if (CirclePath)
                {
                    gfx.FillEllipse(new SolidBrush(Color.Black), e.X - (PenSize / 2), e.Y - (PenSize / 2), PenSize, PenSize);
                }
                else
                {
                    gfx.FillRectangle(new SolidBrush(Color.Black), e.X - (PenSize / 2), e.Y - (PenSize / 2), PenSize, PenSize);
                }

                if (CirclePath)
                {
                    gfx.FillEllipse(new SolidBrush(Color.Black), PrevPos.X - (PenSize / 2), PrevPos.Y - (PenSize / 2), PenSize, PenSize);
                }
                else
                {
                    gfx.FillRectangle(new SolidBrush(Color.Black), PrevPos.X - (PenSize / 2), PrevPos.Y - (PenSize / 2), PenSize, PenSize);
                }

                pictureBox1.Refresh();


            }
            else if (e.Button == System.Windows.Forms.MouseButtons.Right & !LeftIsDown)
            {
                //Right

                Pen Pencil = new Pen(Color.Black, PenSize);
                Graphics gfx = Graphics.FromImage(pictureBox1.Image);
                gfx.DrawLine(Pencil, PrevPos, e.Location);

                if (CirclePath)
                {
                    gfx.FillEllipse(new SolidBrush(Color.Black), e.X - (PenSize / 2), e.Y - (PenSize / 2), PenSize, PenSize);
                }
                else
                {
                    gfx.FillRectangle(new SolidBrush(Color.Black), e.X - (PenSize / 2), e.Y - (PenSize / 2), PenSize, PenSize);
                }

                if (CirclePath)
                {
                    gfx.FillEllipse(new SolidBrush(Color.Black), PrevPos.X - (PenSize / 2), PrevPos.Y - (PenSize / 2), PenSize, PenSize);
                }
                else
                {
                    gfx.FillRectangle(new SolidBrush(Color.Black), PrevPos.X - (PenSize / 2), PrevPos.Y - (PenSize / 2), PenSize, PenSize);
                }

                pictureBox1.Refresh();
            }
            PrevPos = e.Location;

        }

        private void pictureBox1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left & !RightIsDown)
            {
                //Left

                Pen Pencil = new Pen(Color.Black);
                Graphics gfx = Graphics.FromImage(pictureBox1.Image);

                gfx.DrawLine(Pencil, PrevPos, e.Location);

                pictureBox1.Refresh();

                LeftIsDown = false;
            }
            else if (e.Button == System.Windows.Forms.MouseButtons.Right & !LeftIsDown)
            {
                //Right

                Pen Pencil = new Pen(Color.Black);
                Graphics gfx = Graphics.FromImage(pictureBox1.Image);
                gfx.DrawLine(Pencil, PrevPos, e.Location);
                pictureBox1.Refresh();
                RightIsDown = false;
            }
        }
        #endregion

        #region "SerialPort Functions"


        private void UpdateCOMPortList()
        {
            int i;
            bool foundDifference;

            i = 0;
            foundDifference = false;

            //If the number of COM ports is different than the last time we
            //  checked, then we know that the COM ports have changed and we
            //  don't need to verify each entry.
            if (comboBox1.Items.Count == SerialPort.GetPortNames().Length)
            {
                //Search the entire SerialPort object.  Look at COM port name
                //  returned and see if it already exists in the list.
                foreach (string s in SerialPort.GetPortNames())
                {
                    //If any of the names have changed then we need to update 
                    //  the list
                    if (comboBox1.Items[i++].Equals(s) == false)
                    {
                        foundDifference = true;
                    }
                }
            }
            else
            {
                foundDifference = true;
            }

            //If nothing has changed, exit the function.
            if (foundDifference == false)
            {
                return;
            }

            //If something has changed, then clear the list
            comboBox1.Items.Clear();

            //Add all of the current COM ports to the list
            foreach (string s in SerialPort.GetPortNames())
            {
                comboBox1.Items.Add(s);
            }
            //Set the listbox to point to the first entry in the list
            comboBox1.SelectedIndex = 0;
        }

        private void DataReceivedHandler(object sender, SerialDataReceivedEventArgs e)
        {

          //  serialPort1 = (SerialPort)sender;
     
            // byte[] buffer = new byte[serialPort1.ReadBufferSize];
            // int Readbytes = serialPort1.Read(rxbuf, 0, rxbuf.Length);
            //rxString += Encoding.ASCII.GetString(buffer, 0, Readbytes);
           
                rxString = serialPort1.ReadExisting();

           //     SetValue(label1, rxString);

         
           // MessageBox.Show(rxString);
            //if (rxString.IndexOf((char)0x0F) > -1)
            //{
            //    string nextstring = rxString.Substring(0, rxString.IndexOf((char)0x0F));
            //    rxString = rxString.Substring(rxString.IndexOf((char)0x0F));
            //    MessageBox.Show(nextstring);

            //}
            // Thread.Sleep(32);
            // rxString = serialPort1.ReadExisting();
            //// serialPort1.Read(
            // serialPort1.Read(rxbuf, 0, 16);
             
             pause = Convert.ToBoolean(rxString.Contains("DLY"));
             
             //rxString = null;
         


        }



        #endregion 


        #region "Sketch Drive Thread Functions"

        private void runstartup()
        {
            int tog = 1;
            while (Startup)
            {
                SetPictureBoxVisiblity(pictureBox2, tog = 1 - tog);
                serialPort1.Write("101032" + "0" + "0" + "000" + "000" + "000" + "0" + "0" + "1" + "000000001010");
             
                Thread.Sleep(500);
                serialPort1.Write("101032" + "0" + "0" + "000" + "000" + "000" + "0" + "0" + "0" + "000000001010");
                
            }
            SetPictureBoxVisiblity(pictureBox2, true);

        }


        private void rungraphic()
        {
            while (IsRunning)
            {

                SetPictureBoxPos(pictureBox2, xpos[gi]-2, ypos[gi]-2);

                RefreshPictureBox(pictureBox1);

              //  SetValue(label7, gi);

                Thread.Sleep(100);
            }
           
        }

        private void runstopped()
        {
            while (Stopped)
            {



                Thread.Sleep(100);
            }

        }



        private void rundrive()
        {

            if (Reverse_Enable == 0)
            {
                for (gi = 0; gi < pcount; gi++)
                {

                    if (Connected)
                        serialPort1.Write("1010320" + Dir[gi].ToString() + "000" + "000" + ReEn + EngSpVal + TuDel + "1" + "0" + Lights_ON.ToString() + "000000001010");


                    while (pause)
                    {
                        
                        if (!rotating)
                        {
                            RotatePictureBox(pictureBox2, gi);
                            rotating = true;
                        }
                        Thread.Sleep(100);
                    }
                    rotating = false;
                    System.Threading.Thread.Sleep(200);

                }
            }
            else
            {
                for (gi = pcount-1; gi > 0; gi--)
                {

                    if (Connected)
                        serialPort1.Write("1010320" + Dir[gi].ToString() + "000" + "000" + ReEn + EngSpVal + TuDel + "1" + "0" + Lights_ON.ToString() + "000000001010");


                    while (pause)
                    {
                        if (!rotating)
                        {
                            RotatePictureBox(pictureBox2, gi);
                            rotating = true;
                        }
                        Thread.Sleep(100);
                    }

                    System.Threading.Thread.Sleep(200);
                    rotating = false;
                }
            }



            if (Connected)
                serialPort1.Write("1010320" + Dir[pcount - 1].ToString() + "000" + "000" + "000" + "0" + "0" + Lights_ON.ToString() + "000000001010");

            
              EndofDrive();

        }


        #endregion 

        #region "Sketch Drive Functions"

        private void PreSetup()
        {
            if (Reverse_Enable == 0)
                RotatePictureBox(pictureBox2, 0);
            else
            {
                RotatePictureBox(pictureBox2, pcount - 1);
            }
            ReEn = Reverse_Enable.ToString();
            EngSpVal = Engine_Speed[(int)slide1.Value].ToString();
            TuDel = Turn_Delay[(int)knob1.Value].ToString();
            pDir = firstDirection();
            
        }

        private int firstDirection()
        {
            int dir = 0; ;

            for (UInt32 i = 1; i < 16; i++)
            {

                xdirection = xpos[i] - xpos[i - 1];
                ydirection = ypos[i] - ypos[i - 1];

                if (Math.Abs((ypos[i] - ypos[i - 1])) > Math.Abs((xpos[i] - xpos[i - 1])))
                {

                    if ((ypos[i] - ypos[i - 1]) > 1)
                    {
                        //  MessageBox.Show("Y DIR");

                        dir = 2;
                    }
                    else if ((ypos[i] - ypos[i - 1]) < -1)
                    {
                        //  MessageBox.Show("-Y DIR");

                        dir = 3;

                    }

                }
                else
                {
                    if ((xpos[i] - xpos[i - 1]) > 1)
                    {
                        //MessageBox.Show("X DIR");

                        dir = 0;
                    }
                    else if ((xpos[i] - xpos[i - 1]) < -1)
                    {
                        //  MessageBox.Show("-X DIR");

                        dir = 1;
                    }


                }


            }

            return dir;

        }

        private void Get_Sense()
        {

            Sense_Plus = Sense_Value[(int)slide2.Value];
            Sense_Minus = (-1) * (Sense_Value[(int)slide2.Value]);
        }

        private string Get_3DString(int xv)
        {
            string ret = "000";

            if ((xv >= 0) && (xv < 10))
                ret = "00" + xv.ToString();
            else if ((xv > 10) && (xv < 100))
                ret = "0" + xv.ToString();
            else
            {            
                    ret = xv.ToString();

            }

            return ret;
        }

        private void processCode()
        {
            int pmval = 0;
            int dir = 0;
            int i = 0;
            int v = 0;
            int error_count = 0;


            Get_Sense();



            Xval[v] = xpos[0];
            Yval[v] = ypos[0];
 
            mval = firstDirection();
            pmval = firstDirection();
            Dir[0] = firstDirection();
            xDir[0] = xpos[1] - xpos[0];
            yDir[0] = ypos[1] - ypos[0];
            
            
            for (i = 0; i < pcount; i++)
            {
                
                if (i != 0)
                {
                    xdirection = xpos[i] - xpos[i - 1];
                    ydirection = ypos[i] - ypos[i - 1];
                    xDir[i] = xpos[i] - xpos[i - 1];
                    yDir[i] = ypos[i] - ypos[i - 1];
                    
                    if (Math.Abs((ypos[i] - ypos[i - 1])) > Math.Abs((xpos[i] - xpos[i - 1])))
                    {

                        if ((ypos[i] - ypos[i - 1]) > Sense_Plus)
                        {
                            //  MessageBox.Show("Y DIR");
                            error_count++;
                            mval = 2;
                        }
                        else if ((ypos[i] - ypos[i - 1]) < Sense_Minus)
                        {
                            //  MessageBox.Show("-Y DIR");

                            mval = 3;
                            error_count++;

                        }

                    }
                    else
                    {
                        if ((xpos[i] - xpos[i - 1]) > Sense_Plus)
                        {
                            //MessageBox.Show("X DIR");

                            mval = 0;
                            error_count++;
                        }
                        else if ((xpos[i] - xpos[i - 1]) < Sense_Minus)
                        {
                            //  MessageBox.Show("-X DIR");

                            mval = 1;
                            error_count++;
                        }


                    }

                    Dir[++dir] = mval;

                }


             
                if (mval != pmval)
                {

                    if (error_count < Error_Value[(int)slide3.Value])
                    {

                        ClearMetaData();
                        RoutingError = true;
                    }
                    error_count = 0;



                    Xval[v + 1] = xpos[i];
                    Yval[v + 1] = ypos[i];

                    npoints = v + 1;
                    v++;

                }


                pmval = mval;

            }

            Xval[v + 1] = xpos[i - 1];
            Yval[v + 1] = ypos[i - 1];

           
            npoints = v + 1;
            
           
        }


        private void ParseData()
        {
            if ((rxString != null) && ( (rxString.Length == 9)))
            {
                String voltage = rxString.Substring(3, 2);
                Voltage = Convert.ToInt16(voltage);


                String speed = rxString.Substring(5, 3);
                Speed = Convert.ToInt16(speed);

                
            }
            
        }

        private void EndofDrive()
        {
            drivecompleted = true;
            Stopwatch1.Stop();
            timer2.Start();
            IsRunning = false;
            Stopped = true;
            this.StoppedThread = new Thread(new ThreadStart(this.runstopped));
            this.StoppedThread.Start();
            
        }

        private void UpdateGUI()
        {

            if (Voltage < 18)
            {
                pictureBox4.BackgroundImage = Properties.Resources.b4;
            }
            else if ((Voltage < 22) && (Voltage >= 18))
            {
                pictureBox4.BackgroundImage = Properties.Resources.b3;
            }
            else if ((Voltage < 25) && (Voltage >= 22))
            {
                pictureBox4.BackgroundImage = Properties.Resources.b2;
            }
            else 
            {
                pictureBox4.BackgroundImage = Properties.Resources.b1;
            }
  
            TimeSpan ts = Stopwatch1.Elapsed;

            label9.Text = String.Format("{0:00}:{1:00}:{2:00}",
            ts.Hours, ts.Minutes, ts.Seconds);

            

        }

        private void SetGauge(){
            int loc_speed = 0;
            while(true){
                if(Speed <= 999)
                loc_speed = (Speed * 140)/999;

                if (loc_speed <= 140)
                {
                    if ((loc_speed - prev_Gaugevalue) > 0)
                    {
                        for (int i = prev_Gaugevalue; i <= loc_speed; i++)
                        {
                            SetGaugeValue(gauge1, i);
                            Thread.Sleep(20);
                        }
                    }
                    else if ((loc_speed - prev_Gaugevalue) <= 0)
                    {
                        for (int i = prev_Gaugevalue; i >= loc_speed; i--)
                        {
                            SetGaugeValue(gauge1, i);
                            Thread.Sleep(20);
                        }
                    }
                    else
                    {
                     
                    }

                    prev_Gaugevalue = loc_speed;
                }

                Thread.Sleep(100);
            }
        }

       
        private void ClearMetaData()
        {
            
            timer2.Stop();

            pcount = 0;
            Graphics gfx = Graphics.FromImage(pictureBox1.Image);
            gfx.Clear(Color.FromArgb(255, 255, 255, 255));
            pictureBox1.Refresh();

         
                if (Dir[0] == 0)
                {
                    pictureBox2.Image = Properties.Resources.nav_icon_90;
                }
                else if (Dir[0] == 1)
                {
                    pictureBox2.Image = Properties.Resources.nav_icon_270;
                }
                else if (Dir[0] == 2)
                {
                    pictureBox2.Image = Properties.Resources.nav_icon_180;
                }
                else
                {
                    pictureBox2.Image = Properties.Resources.nav_icon_0;
                }
            

           

            Startup = false;
            Stopped = false;
            pictureBox3.Visible = false;
            pictureBox2.Visible = false;
            pictureBox2.Refresh();
            Array.Clear(xpos, 0, xpos.Length);
            Array.Clear(ypos, 0, ypos.Length);
            Array.Clear(Xval, 0, Xval.Length);
            Array.Clear(Yval, 0, Yval.Length);
            Array.Clear(Dir, 0, Dir.Length);
            
            led3.Value = false;
            led2.Value = false;
            Stopwatch1.Reset();
            label9.Text = "00:00:00";
            label1.Text = "0";

        }

        #endregion



        #region "Cross Thread"

        private void SetValue(Control ctrl, string value)
        {

            if (ctrl.InvokeRequired)
            {
                SetValueCallback call = new SetValueCallback(SetValue);
                Invoke(call, new object[] { ctrl , value });
            }
            else
            {
                ctrl.Text = value;
            }

 
        }

        private void SetGaugeValue(Gauge ctrl, int value)
        {

            if (ctrl.InvokeRequired)
            {
                SetGaugeValueCallback call = new SetGaugeValueCallback(SetGaugeValue);
                Invoke(call, new object[] { ctrl, value });
            }
            else
            {
                ctrl.Value = value;
                
            }


        }


        private void RotatePictureBox(PictureBox ctrl, UInt32 value)
        {
            if (ctrl.InvokeRequired)
            {
                ctrl.BeginInvoke(new MethodInvoker(delegate
                {
                    if (Dir[value] == 0)
                    {
                        pictureBox2.Image = Properties.Resources.nav_icon_90;
                        
                    }
                    else if (Dir[value] == 1)
                    {
                        pictureBox2.Image = Properties.Resources.nav_icon_270;
                    }
                    else if (Dir[value] == 2)
                    {
                        pictureBox2.Image = Properties.Resources.nav_icon_180;
                    }
                    else
                    {
                        pictureBox2.Image = Properties.Resources.nav_icon_0;
                    }
                }));
            }
            else
            {
                if (Dir[value] == 0)
                {
                    pictureBox2.Image = Properties.Resources.nav_icon_90;
                }
                else if (Dir[value] == 1)
                {
                    pictureBox2.Image = Properties.Resources.nav_icon_270;
                }
                else if (Dir[value] == 2)
                {
                    pictureBox2.Image = Properties.Resources.nav_icon_180;
                }
                else
                {
                    pictureBox2.Image = Properties.Resources.nav_icon_0;
                }
            }

        }



        private void SetPictureBoxVisiblity(PictureBox ctrl, object value)
        {
            if (ctrl.InvokeRequired)
            {
                ctrl.BeginInvoke(new MethodInvoker(delegate
                {
                    ctrl.Visible = Convert.ToBoolean(value);
                }));
            }
            else
            {
                ctrl.Visible = Convert.ToBoolean(value);
            }
        }

        private void SetPictureBoxAngle(PictureBox ctrl, object value)
        {
            
            if (ctrl.InvokeRequired)
            {
                ctrl.BeginInvoke(new MethodInvoker(delegate
                {
                    Graphics gfx = Graphics.FromImage(ctrl.Image);

                    gfx.RotateTransform((float)value);

                }));
            }
            else
            {
                Graphics gfx = Graphics.FromImage(ctrl.Image);

                gfx.RotateTransform((float)value);

            }
        }



        private void SetPictureBoxPos(PictureBox ctrl, object x1, object y1)
        {


            if (ctrl.InvokeRequired)
            {
                ctrl.BeginInvoke(new MethodInvoker(delegate
                {
                    ctrl.SetBounds((int)x1, (int)y1, picW, picH);
                }));
            }
            else
            {
                ctrl.SetBounds((int)x1, (int)y1, picW, picH);
            }


        }


        private void RefreshPictureBox(PictureBox ctrl)
        {

            if (ctrl.InvokeRequired)
            {
                ctrl.BeginInvoke(new MethodInvoker(delegate
                {
                    ctrl.Refresh();
                }));
            }
            else
            {
                ctrl.Refresh();
            }

         }

        #endregion

        private void buttonConnect_Click(object sender, EventArgs e)
        {
            if (Connected == false)
            {
                try
                {
                    //Get the port name from the application list box.
                    //  the PortName attribute is a string name of the COM
                    //  port (e.g. - "COM1").
                    serialPort1.PortName = comboBox1.Items[comboBox1.SelectedIndex].ToString();

                    //Open the COM port.
                    serialPort1.Open();

                    //Change the state of the application objects

                    Connected = true;

                    led1.Value = true;
                    buttonConnect.Text = "Disconnect";

                    // button4.Enabled = false;
                    comboBox1.Enabled = false;

                }
                catch
                {

                }
            }
            else
            {

                //Reset the state of the application objects
                Connected = false;
                led1.Value = false;
                buttonConnect.Text = "Connect";
                // button4.Enabled = true;
                comboBox1.Enabled = true;

                try
                {
                    //Dispose the In and Out buffers;
                    serialPort1.DiscardInBuffer();
                    serialPort1.DiscardOutBuffer();

                    //Close the COM port
                    serialPort1.Close();
                }
                //If there was an exeception then there isn't much we can
                //  do.  The port is no longer available.
                catch { }
            }
        }

        private void buttonCompile_Click(object sender, EventArgs e)
        {

            if (pcount > 0 && (Reverse_Enable == 0))
            {
                processCode();

                if (RoutingError)
                {
                    led2.Value = false;
                    led3.Value = true;
                    MessageBox.Show("Routing Error");
                    RoutingError = false;
                }
                else
                {
                    led3.Value = false;
                    led2.Value = true;
                    label1.Text = npoints.ToString();
          
                    MessageBox.Show("Routing Done");
                    pathfound = true;

                    RotatePictureBox(pictureBox2, 0);


                    pictureBox2.Visible = true;
                    pictureBox3.Visible = true;


                    if (Reverse_Enable == 0)
                    {
                        pictureBox2.SetBounds(xpos[0] - 2, ypos[0] - 2, picW, picH);
                        pictureBox3.SetBounds(xpos[pcount - 1] - 2, ypos[pcount - 1] - 2, picW, picH);
                    }
                    else
                    {
                        pictureBox3.SetBounds(xpos[0] - 2, ypos[0] - 2, picW, picH);
                        pictureBox2.SetBounds(xpos[pcount - 1] - 2, ypos[pcount - 1] - 2, picW, picH);
                    }
                    Startup = true;
                    Stopped = false;
                    this.StartupThread = new Thread(new ThreadStart(this.runstartup));
                    this.StartupThread.Start();



                }

            }
            else
            {
                MessageBox.Show("Routing Failed");
            }
        }

        private void buttonRun_Click(object sender, EventArgs e)
        {
            if ((Startup || Stopped)&& (!OpMode))
            {
                this.RunThread = new Thread(new ThreadStart(this.rundrive));
                this.GraphicThread = new Thread(new ThreadStart(this.rungraphic));

                PreSetup();
                timer2.Stop();
                Startup = false;
                Stopped = false;

                Stopwatch1.Reset();

                IsRunning = true;
                Stopwatch1.Start();

                this.RunThread.Start();
                this.GraphicThread.Start();

            }
        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            ClearMetaData();
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            UpdateCOMPortList();
        }

        private void timer3_Tick(object sender, EventArgs e)
        {

            ParseData();

            UpdateGUI();
     
        }

        private void switch1_StateChanged(object sender, ActionEventArgs e)
        {
            Reverse_Enable = Convert.ToInt16(switch1.Value);
            if (switch1.Value)
                label3.ForeColor = Color.Red;
            else
                label3.ForeColor = Color.Black;

        }

        private void switch2_StateChanged(object sender, ActionEventArgs e)
        {
            Lights_ON = Convert.ToInt16(switch2.Value);
            if (Connected)
            {
                if (OpMode)
                {
                    serialPort1.Write("101032" + "1" + "0" + "000" + "000" + "000" + "0" + "0" + Lights_ON.ToString() + Convert.ToString(td_Drive) + Convert.ToString(td_Reverse) + Convert.ToString(td_Left) + Convert.ToString(td_Right) + td_Speed + "01010");
                }
                else
                {
                    serialPort1.Write("101032" + "0" + "0" + "000" + "000" + "000" + "0" + "0" + Lights_ON.ToString() + "000000001010");
                }
            }
        }


        #region "Test Drive"

        /*
        void Touch_FrameReported(object sender, TouchFrameEventArgs e)
        {
            TouchPoint primaryTouchPoint = e.GetPrimaryTouchPoint(null);


            TouchPointCollection touchPoints = e.GetTouchPoints(null);


            foreach (TouchPoint tp in touchPoints)
            {
                if (tp.Action == TouchAction.Down)
                {
                    //Do stuff here
                }

            }
        }

        */

        private void SetMeter()
        {

            Thread.Sleep(1000);
            while ((td_Drive == 1) && (td_SpeedVal < td_MaxSpeed))
            {
                meter1.Value = ((td_SpeedVal * 140) / 100);
                td_Speed = Get_3DString((int)meter1.Value);
                Thread.Sleep(30);

                td_SpeedVal++;
            }
             if (td_Circuit == 1 && td_Drift ==0)
            {
                if (td_LorR == 0)
                    td_Left = 1;
                else
                    td_Right = 1;

                td_SpeedVal = td_MaxSpeed-1;
                meter1.Value = ((td_SpeedVal * 140) / 100);
                td_Speed = Get_3DString((int)meter1.Value);
                while (td_Drive == 1) ;
                td_Left = 0;
                td_Right = 0;

            }
           

        }

        private void ResetMeter()
        {

            if (td_Drift == 1 && td_Circuit == 0)
            {
                if (td_LorR == 0)
                    td_Left = 1;
                else
                    td_Right = 1;
                td_SpeedVal = 0;
                Lights_ON = 1;
                meter1.Value = ((td_SpeedVal * 140) / 100);
                td_Speed = Get_3DString((int)meter1.Value);
                Thread.Sleep(3000);
                td_Left = 0;
                td_Right = 0;
                Lights_ON = 0;
               
            }
            else
            {
                while ((td_Drive == 0) && (td_SpeedVal > 0))
                {
                    td_SpeedVal--;
                    meter1.Value = ((td_SpeedVal * 140) / 100);
                    td_Speed = Get_3DString((int)meter1.Value);
                    Thread.Sleep(30);

                }

            }
        }





        private void buttonDrive_MouseDown(object sender, MouseEventArgs e)
        {
            if (OpMode)
            {
         
                td_Drive = 1;
                this.SetMeterThread = new Thread(new ThreadStart(this.SetMeter));
                this.SetMeterThread.Start();


            }
        }

        private void buttonDrive_MouseUp(object sender, MouseEventArgs e)
        {
            if (OpMode)
            {

               
                td_Drive = 0;
                this.ResetMeterThread = new Thread(new ThreadStart(this.ResetMeter));
                this.ResetMeterThread.Start();
              
            } 
        }

        private void buttonReverse_Click(object sender, EventArgs e)
        {
            if (OpMode)
            {
                td_Reverse = 1 - td_Reverse;

                if (td_Reverse == 1)
                {
                    Reverse_Enable = 1;
                    buttonReverse.Text = "R";
                    buttonReverse.ForeColor = Color.Red;
                }
                else
                {
                    Reverse_Enable = 0;
                    buttonReverse.Text = "D";
                    buttonReverse.ForeColor = Color.Green;
                }
            }
        }


        private void buttonRight_MouseDown(object sender, MouseEventArgs e)
        {
            if (OpMode)
            {
                
                td_Right = 1;
               
            }
        }

        private void buttonRight_MouseUp(object sender, MouseEventArgs e)
        {
            if (OpMode)
            {
                td_Right = 0;
            }
        }

        private void buttonLeft_MouseDown(object sender, MouseEventArgs e)
        {
            if (OpMode)
            {
                
                td_Left = 1;

            }
        }

        private void buttonLeft_MouseUp(object sender, MouseEventArgs e)
        {
            if (OpMode)
            {
                td_Left = 0;
            }
        }


        private void switch3_StateChanged(object sender, ActionEventArgs e)
        {
            OpMode = switch3.Value;

            if (OpMode)
            {
                timer2.Stop();
                timer4.Interval = 600;
                timer4.Enabled = true;
                timer4.Start();
            }
            else
            {
                timer4.Stop();
                timer2.Start();
            }

        }

        private void timer4_Tick(object sender, EventArgs e)
        {
            if (Connected)
            {

                serialPort1.Write("101032" + "1" + "0" + "000" + "000" + Reverse_Enable.ToString() +"00" + "1" + "0" + Lights_ON.ToString() + td_Drive.ToString() + td_Reverse.ToString() + td_Left.ToString() + td_Right.ToString() + td_Speed + "01010");

            }
            label12.Text = Get_3DString((int)meter1.Value);
        }

        private void slide5_AfterChangeValue(object sender, AfterChangeNumericValueEventArgs e)
        {
            td_MaxSpeed = (uint)slide5.Value;

        }



        private void switch4_StateChanged(object sender, ActionEventArgs e)
        {
            if(td_Circuit ==0)
            td_Drift = Convert.ToInt16(switch4.Value);
        }

        private void switch5_StateChanged(object sender, ActionEventArgs e)
        {
            if(td_Drift == 0)
            td_Circuit = Convert.ToInt16(switch5.Value);
        }





        private void buttonLorR_Click(object sender, EventArgs e)
        {
            td_LorR = 1 - td_LorR;

            if (td_LorR == 1)
            {
                buttonLorR.Image = Properties.Resources.navigate_right_icon;
            }
            else
            {
                buttonLorR.Image = Properties.Resources.navigate_left_icon;
            
            }
        }

        #endregion


    }
}
